#pragma once
/*
ActorsFactory.h+cpp is part of Oxygine-Editor.
it is located at oxygine-editor/examples/Hello/src/
*/
#include "oxygine-include.h"
#if OXYGINE_VERSION > 6
#include "ox/pugixml.hpp"
#include "oxygine/actor/Actor.h"
#include "oxygine/Serialize.h"
#else
#include "ox/pugixml.hpp"
#include "ox/Actor.hpp"
#include "ox/Serialize.hpp"
#endif

#include <vector>
namespace oxygine
{
    /**
    associates data from xml with generated classes
    */
    void associateActorClasses(const pugi::xml_document& doc);
    pugi::xml_node getActorClassNode(const pugi::xml_document& doc, const char* name);



    class factory: public creator
    {
    public:
        factory(): _parent(0) {}
        void clear();
        factory* _parent;

        std::vector<Resources*> _res;
        void add(Resources* r);
        spActor create(const char* type) const;
        Resource* getResource(const char* id) const;
    };

    class ActorX : public Actor
    {
    protected:
        Actor* _findDescendant(const char* name);
        static Actor* _findDescendantX(Actor* parent, const char* name);
    };


    class Actor;

    typedef Actor* (*createActorCallback)(const creator*);
    typedef void (*associateNodeCallback)(pugi::xml_node node);
    bool registerFactoryActor(createActorCallback cb, associateNodeCallback an, const char* name);


#define REGISTER_ACTOR(cl) bool __registeredActor##cl = registerFactoryActor(cl::__create, cl::__associate, cl::__type()); \
    pugi::xml_node cl::__classNode; \
    void cl::__init(const creator &f, pugi::xml_node customNode)\
    {   _flags |= flag_reserved; deserializedata d; d.node = customNode ? customNode : __classNode; d.factory = &f; deserialize(&d); \
        deserializeLinkData link; _ref_counter++; link.root = this; link.node = __classNode; deserializeLink(&link); link.root = 0; _ref_counter--;\
        __init();\
    }\
    cl::cl(const creator &f, pugi::xml_node customNode){__init(f, customNode);} \
    cl::cl(){}\
    cl::~cl(){}\

    spActor createActor(const factory& factory, const pugi::xml_document& doc, const std::string& name);


#define FACTORY_ACTOR(cl, name) public: \
        cl();\
        ~cl();\
        cl(const creator &f, pugi::xml_node customNode = pugi::xml_node());\
        void __init(const creator &f, pugi::xml_node customNode);\
        void __init();\
        static const char *__type() {return name;} \
        static pugi::xml_node __classNode; \
        static void __associate(pugi::xml_node node) {__classNode = node;} \
        static Actor *__create(const creator *f) {return new cl(*f);}



#define REGISTER_CUSTOM_ACTOR(cl) bool __registeredActor##cl = registerFactoryActor(cl::__create, cl::__associate, cl::__type()); \
    pugi::xml_node cl::__classNode; \
    cl::cl(const creator &f, pugi::xml_node customNode){__init(f, customNode);} \
    cl::cl(){}\
    cl::~cl(){}\


    Actor* createFactoryActor(const char* name, const creator*);
    void associateFactoryActorNode(const char* name, pugi::xml_node node);
}